// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/references -i References -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/items"
	"git.perx.ru/perxis/perxis-go/pkg/references"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements references.References that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   references.References
}

// AccessLoggingMiddleware instruments an implementation of the references.References with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next references.References) references.References {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, spaceId string, envId string, references []*references.Reference, options ...*references.GetOptions) (items []*items.Item, notfound []*references.Reference, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("references", references),
		zap.Reflect("options", options),
	)

	items, notfound, err = m.next.Get(ctx, spaceId, envId, references, options...)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("items", items),
		zap.Reflect("notfound", notfound),
		zap.Error(err),
	)

	return items, notfound, err
}

func (m *accessLoggingMiddleware) Publish(ctx context.Context, spaceId string, envId string, references []*references.Reference, recursive bool, force bool) (published []*references.Reference, notfound []*references.Reference, unpublished []*references.Reference, err error) {
	begin := time.Now()

	m.logger.Debug("Publish.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("spaceId", spaceId),
		zap.Reflect("envId", envId),
		zap.Reflect("references", references),
		zap.Reflect("recursive", recursive),
		zap.Reflect("force", force),
	)

	published, notfound, unpublished, err = m.next.Publish(ctx, spaceId, envId, references, recursive, force)

	m.logger.Debug("Publish.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("published", published),
		zap.Reflect("notfound", notfound),
		zap.Reflect("unpublished", unpublished),
		zap.Error(err),
	)

	return published, notfound, unpublished, err
}
